<?php

/*
 * vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
 * Codificación: UTF-8
 * +----------------------------------------------------------------------+
 * | Copyright (c) 1997-2005 Palosanto Solutions S. A.                    |
 * +----------------------------------------------------------------------+
 * | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
 * | Telfs. 2283-268, 2294-440, 2284-356                                  |
 * | Guayaquil - Ecuador                                                  |
 * +----------------------------------------------------------------------+
 * | Este archivo fuente está sujeto a las políticas de licenciamiento    |
 * | de Palosanto Solutions S. A. y no está disponible públicamente.      |
 * | El acceso a este documento está restringido según lo estipulado      |
 * | en los acuerdos de confidencialidad los cuales son parte de las      |
 * | políticas internas de Palosanto Solutions S. A.                      |
 * | Si Ud. está viendo este archivo y no tiene autorización explícita    |
 * | de hacerlo, comuníquese con nosotros, podría estar infringiendo      |
 * | la ley sin saberlo.                                                  |
 * +----------------------------------------------------------------------+
 * | Autores: Manuel Olvera <molvera@palosanto.com>                       |
 * +----------------------------------------------------------------------+
 * $Id: ws_attention.php,v 1.0 25/01/2012 02:16:23 PM molvera Exp $
 */

//require_once(realpath(dirname(__FILE__)."/../libs/misc.lib.php"));
//require_once(realpath(dirname(__FILE__)."/../configs/default.conf.php"));
$root = $_SERVER["DOCUMENT_ROOT"];
set_include_path($root . PATH_SEPARATOR . get_include_path());
require_once("libs/misc.lib.php");
require_once("configs/default.conf.php");
require_once("modules/ticket_time_by_customer/configs/default.conf.php");
require_once("modules/ticket_time_by_customer/libs/paloSantoTicketTimebyCustomer.class.php");


function getTicketsData(&$pDB, $arrTickets, $count=FALSE, $limit = NULL, $offset= NULL){
    $where = "cu.ticket IN ('".implode("','",$arrTickets)."')";
    $select = $count?'COUNT(*) as total':'
                   cu.ticket AS ticket,
                   cu.time_bought AS hours_bought,
                   cu.product_quantity AS product_quantity,
                   ct.start_time AS start_date,
                   TIMESTAMPDIFF(second,ct.start_time,ct.end_time) AS hours_attended,
                   u.id AS user_id,
                   u.name AS user_name';
    $query = "SELECT
                   $select
              FROM
                   chat_time ct,
                   customer cu,
                   user u,
                   chat_users ch,
                   chat c
              WHERE
                   ct.id_chat = c.id AND
                   c.id=ch.id_chat AND
                   ch.id_user_response=u.id AND
                   ch.id_user_request=cu.id_user AND
                   (u.id_profile=1 or u.id_profile=2) AND
                   $where
            ";
    if(!$count){
        $query.= 'ORDER BY ct.start_time ';
        if(!empty($limit) && !is_null($offset))
            $query.= "
              LIMIT $limit
              OFFSET $offset";
    }

    $result=$pDB->fetchTable($query, true);
    if($result==FALSE){
        return $pDB->errMsg;
    }
    return $result;
}

function getSupportAttentionCount($arrTickets){
    //global variables
    global $arrConf;
    global $arrConfModule;
    $arrConf = array_merge($arrConf,$arrConfModule);

    $arrSupport = array();

    $pDB = new paloDB($arrConf['dsn_conn_database']['chatroom']);
    $arrResult = getTicketsData($pDB, $arrTickets, TRUE);

    if(!is_array($arrResult) && is_string($arrResult)){
        throw new SoapFault('supportAttentionCount',$arrResult);
    }
    return $arrResult[0]['total'];
}

function getSupportAttentionList($arrTickets, $limit, $offset){
    //global variables
    global $arrConf;
    global $arrConfModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrSupport = array();

    $pDB = new paloDB($arrConf['dsn_conn_database']['chatroom']);

    $pTicketTimebyCustomer = new paloSantoTicketTimebyCustomer($pDB);
    $arrResult = getTicketsData($pDB, $arrTickets, FALSE, $limit, $offset);
    if(!is_array($arrResult) && is_string($arrResult)){
        throw new SoapFault('supportAttention',$arrResult);
    }else
        foreach($arrResult as $row){
            if(!$row['product_quantity'])   $valor = 0;
            else                            $valor = $row['product_quantity'];

            /*$arrSupport[$row['ticket']]['hours_bought'] = ($row['hours_bought']) * $valor;
            if(!isset($arrSupport[$row['ticket']]['secs_remaining']))
                $arrSupport[$row['ticket']]['secs_remaining'] = ($arrSupport[$row['ticket']]['hours_bought']*3600);

            $arrSupport[$row['ticket']]['technician'][$row['user_id']]['user_name'] = $row['user_name'];
            $arrSupport[$row['ticket']]['secs_remaining'] = $arrSupport[$row['ticket']]['secs_remaining'] - (int)$row['hours_attended'];

            $prefix = 0>$arrSupport[$row['ticket']]['secs_remaining']?'-':'';
            $arrSupport[$row['ticket']]['technician'][$row['user_id']]['attention'][] = array(
                'date_attended'     => $row['start_date'],
                'hours_attended'    => $pTicketTimebyCustomer->Sec2HHMMSS($row['hours_attended']),
                'hours_remaining'   => $prefix.$pTicketTimebyCustomer->Sec2HHMMSS(abs($arrSupport[$row['ticket']]['secs_remaining'])),
                'secs_remaining'    => $arrSupport[$row['ticket']]['secs_remaining'],
                'secs_attended'     => $row['hours_attended'],
            );*/
            $arrSupport[$row['ticket']][] = array(
                'user_id'       => $row['user_id'],
                'user_name'     => $row['user_name'],
                'start_date'    => $row['start_date'],
                'secs_attended' => $row['hours_attended'],
                'hours_attended'=> $pTicketTimebyCustomer->Sec2HHMMSS($row['hours_attended']),
                'hours_bought'  => (($row['hours_bought']) * $valor),
            );
        }

        /*foreach($arrSupport as $ticket => $times){
            $prefix = 0>$times['secs_remaining']?'-':'';
            $arrSupport[$ticket]['hours_remaining'] = $prefix.$pTicketTimebyCustomer->Sec2HHMMSS(abs($times['secs_remaining']));
        }*/

    return base64_encode(serialize($arrSupport));
}

// turn off the wsdl cache
ini_set("soap.wsdl_cache_enabled", "0");

$server = new SoapServer("wsdl/attention_support.wsdl");
$server->addFunction("getSupportAttentionList");
$server->addFunction("getSupportAttentionCount");
$server->handle();
